> For the complete documentation index, see [llms.txt](https://robodex.gitbook.io/robodex-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://robodex.gitbook.io/robodex-docs/reference/schema-index.md).

# Schema Index

## Product and frontend shapes

| Shape                     | File                                                    | Purpose                                 |
| ------------------------- | ------------------------------------------------------- | --------------------------------------- |
| `TaskIntent`              | `packages/pipeline/schemas.py` and frontend types       | Normalized user task                    |
| `RobotDesignCandidate`    | `packages/pipeline/schemas.py`, `apps/web/lib/types.ts` | Product-facing candidate                |
| `GenerateDesignsResponse` | `apps/web/lib/types.ts`                                 | Design generation response              |
| `GrammarHitl`             | `apps/web/lib/types.ts`                                 | Grammar-loop review payload             |
| `WorkspaceProject`        | `apps/web/lib/types.ts`                                 | Workspace project                       |
| `WorkspaceThread`         | `apps/web/lib/types.ts`                                 | Workspace thread                        |
| `ThreadArtifact`          | `apps/web/lib/types.ts`                                 | Generated artifact attached to a thread |
| `SimulationSpec`          | `apps/web/lib/types.ts`                                 | Simulation check request/result         |
| `PolicySpec`              | `apps/web/lib/types.ts`                                 | Policy spec request/result              |

## Research shapes

| Shape                | File                                        | Purpose                      |
| -------------------- | ------------------------------------------- | ---------------------------- |
| `AgentLoopConfig`    | `packages/research/agent_loops/protocol.py` | Loop configuration           |
| `AgentLoopResult`    | `packages/research/agent_loops/protocol.py` | Loop return value            |
| `GenerationStrategy` | `packages/research/strategy/protocol.py`    | Experiment strategy protocol |
| `StrategyConfig`     | `packages/research/strategy/protocol.py`    | Strategy configuration       |
| `Experiment`         | `packages/research/experiment/types.py`     | Experiment metadata          |
| `ExperimentRun`      | `packages/research/experiment/types.py`     | One run record               |
| `ReproEnvelope`      | `packages/research/experiment/types.py`     | Reproducibility metadata     |
| `DesignMetrics`      | `packages/research/benchmark/metrics.py`    | Per-design metrics           |
| `MetricsReport`      | `packages/research/benchmark/metrics.py`    | Aggregated metrics           |

## Pipeline shapes

| Shape                | File                                 | Purpose                           |
| -------------------- | ------------------------------------ | --------------------------------- |
| `RobotDesignProgram` | `packages/pipeline/robot_program.py` | Derivation-first body program     |
| `DerivationStep`     | `packages/pipeline/robot_program.py` | One rule application              |
| `GrammarCatalog`     | `packages/pipeline/robot_program.py` | Available symbols and rules       |
| `ExpandedRobotGraph` | `packages/pipeline/robot_program.py` | Expanded generated body graph     |
| `ComponentProgram`   | `packages/pipeline/robot_program.py` | Lowered component-level body      |
| `RobotDesignHitlV2`  | `packages/pipeline/robot_program.py` | Reviewable generated-body payload |
| `ProgramCompilation` | `packages/pipeline/robot_program.py` | Full compilation result           |
| `RobotDesignIR`      | `packages/pipeline/ir/design_ir.py`  | Canonical robot design            |
| `LinkIR`             | `packages/pipeline/ir/design_ir.py`  | Robot link                        |
| `JointIR`            | `packages/pipeline/ir/design_ir.py`  | Robot joint                       |
| `SensorSlot`         | `packages/pipeline/ir/design_ir.py`  | Sensor slot                       |
| `ActuatorSlot`       | `packages/pipeline/ir/design_ir.py`  | Actuator slot                     |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://robodex.gitbook.io/robodex-docs/reference/schema-index.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
